/* Generated By:JavaCC: Do not edit this line. EOLParser.java */
package eol.compiler ;

import eol.vm.* ;
import util.Assert ;

/** This is the parser class for the compiler.
    It also contains the main function.
*/
public class EOLParser implements EOLParserConstants {

    public Machine m = new Machine()  ;

    public void mainLoop(boolean verbose, boolean tracing) {
        m.setVerbose( verbose ) ;
        m.setTracing( tracing ) ;
        boolean quit ;
        do {
            System.out.print( token==null ? "? " : ((token.beginLine+1)+"? ") );
            System.out.flush() ;
            quit = false ;
            try { quit = Item() ; }
            catch( ParseException e ) {
                 System.out.println( e.getMessage() ) ;
                 recover() ; }
            catch( CompileTimeError e ) {
                System.out.println( e.getMessage() ) ;
                recover() ; }
            catch( Machine.ExecutionError e ) {
                System.out.println( e.getMessage() ) ; }
            catch( Throwable e ) {
                e.printStackTrace( System.out );
                quit = e instanceof Error ;
                if( ! quit ) recover() ; }
        } while( !quit ) ;
     }

    /** Skip to the next semicolon or EOF */
    void recover() {
        System.out.println( "Enter a ';' before entering next function or expression" ) ;
        while( true ) {
            Token t = getNextToken() ;
            if( t.kind == EOLParserConstants.SEMICOLON || t.kind == 0) break ;
        }
    } ;

  /** Deal with special sequences in strings */
  String processEscapes( String in ) throws ParseException {
        StringBuffer buf = new StringBuffer() ;
        for( int i=1 , sz = in.length()-1 ; i < sz ; ++i ) {

            char ch = in.charAt(i) ;
            if( in.charAt(i) == '\u005c\u005c' ) {
                ++i ;
                switch( in.charAt(i) ) {
                case '\u005c\u005c': ch = '\u005c\u005c' ; break ;
                case 'n':  ch = '\u005cn' ; break ;
                case 'r':  ch = '\u005cr' ; break ;
                case '"':  ch = '"'  ; break ;
                default: throw new ParseException( "Unknown escape in string: \u005c\u005c"+in.charAt(i) ) ; } }
          buf.append( ch ) ;}
        return buf.toString() ; }

/**********************************************************
** The Context Free Grammar begins here.
***********************************************************/
  final public boolean Item() throws ParseException, Machine.ExecutionError, CompileTimeError {
  int segNum ;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LPAR:
    case LBRACKET:
    case FUNSTART:
    case LET:
    case NUM:
    case ID:
    case STRING:
          segNum = m.startSegment() ;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LET:
        Def();
        break;
      case LPAR:
      case LBRACKET:
      case FUNSTART:
      case NUM:
      case ID:
      case STRING:
        Expr();
        break;
      default:
        jj_la1[0] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
          m.emit( InstructionSet.PRINT ) ;
          m.emit( InstructionSet.RETURN ) ;
          m.endSegment() ;
          m.execute( segNum) ;
      jj_consume_token(SEMICOLON);
             {if (true) return false ;}
      break;
    case SEMICOLON:
      jj_consume_token(SEMICOLON);
             {if (true) return false ;}
      break;
    case 0:
    case BYE:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BYE:
        jj_consume_token(BYE);
        break;
      case 0:
        jj_consume_token(0);
        break;
      default:
        jj_la1[1] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
             {if (true) return true ;}
      break;
    default:
      jj_la1[2] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public void Block() throws ParseException, CompileTimeError {
      m.emit( InstructionSet.START_ENV ) ;
    Block1();
      m.emit( InstructionSet.END_ENV ) ;
  }

  final public void Block1() throws ParseException, CompileTimeError {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LPAR:
    case LBRACKET:
    case FUNSTART:
    case NUM:
    case ID:
    case STRING:
      Expr();
      MoreBlock();
      break;
    case LET:
      Def();
      MoreBlock();
      break;
    default:
      jj_la1[3] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void MoreBlock() throws ParseException, CompileTimeError {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SEMICOLON:
      jj_consume_token(SEMICOLON);
      Block1();
      break;
    default:
      jj_la1[4] = jj_gen;

    }
  }

  final public void Def() throws ParseException, CompileTimeError {
    Token t ;
    int id ;
    jj_consume_token(LET);
    t = jj_consume_token(ID);
    jj_consume_token(BECOMES);
    Expr();
      id = m.interString( t.image ) ;
      m.emit( InstructionSet.NEW_VAR, id, 3 ) ;
  }

  final public void Expr() throws ParseException, CompileTimeError {
    Token t ;
    int id ;
    if (jj_2_1(2147483647)) {
      t = jj_consume_token(ID);
      jj_consume_token(BECOMES);
      Expr();
      id = m.interString( t.image ) ;
      m.emit( InstructionSet.STORE, id, 3 ) ;
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAR:
      case LBRACKET:
      case FUNSTART:
      case NUM:
      case ID:
      case STRING:
        Call();
        break;
      default:
        jj_la1[5] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

// TODO add productions to deal with  =, :,  , +, -, *, /, and Factors
  final public void Call() throws ParseException, CompileTimeError {
    int argCount ;
    Primary();
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAR:
        ;
        break;
      default:
        jj_la1[6] = jj_gen;
        break label_1;
      }
      argCount = Args();
          m.emit( InstructionSet.CALL, argCount, 3 ) ;
    }
  }

  final public int Args() throws ParseException, CompileTimeError {
    int argCount ;
    jj_consume_token(LPAR);
    argCount = ExprSequence();
    jj_consume_token(RPAR);
     {if (true) return argCount;}
    throw new Error("Missing return statement in function");
  }

  final public int ExprSequence() throws ParseException, CompileTimeError {
    int count ;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LPAR:
    case LBRACKET:
    case FUNSTART:
    case NUM:
    case ID:
    case STRING:
      Expr();
      count = MoreExprSequence();
                                     {if (true) return count+1;}
      break;
    default:
      jj_la1[7] = jj_gen;
      {if (true) return 0;}
    }
    throw new Error("Missing return statement in function");
  }

  final public int MoreExprSequence() throws ParseException, CompileTimeError {
    int count ;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMA:
      jj_consume_token(COMMA);
      Expr();
      count = MoreExprSequence();
                                              {if (true) return count+1 ;}
      break;
    default:
      jj_la1[8] = jj_gen;
      {if (true) return 0 ;}
    }
    throw new Error("Missing return statement in function");
  }

  final public void Primary() throws ParseException, CompileTimeError {
    Token t ;
    Double d ;
    String str ;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ID:
      t = jj_consume_token(ID);
                            m.emit( InstructionSet.FETCH, m.interString(t.image), 3) ;
      break;
    case NUM:
      t = jj_consume_token(NUM);
                            try{d = Double.parseDouble( t.image ) ; }
                            catch( NumberFormatException e) { Assert.notReached() ; d=0.0 ; }
                            m.emit( InstructionSet.CONST, m.interDouble(d), 3) ;
      break;
    case STRING:
      t = jj_consume_token(STRING);
                            str = processEscapes( t.image ) ;
                            m.emit( InstructionSet.CONST, m.interString( str ), 3) ;
      break;
    case FUNSTART:
      Function();
      break;
    case LPAR:
      jj_consume_token(LPAR);
      Block();
      jj_consume_token(RPAR);
      break;
    case LBRACKET:
      List();
      break;
    default:
      jj_la1[9] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void Function() throws ParseException, CompileTimeError {
    int paramCount ;
    int segNum ;
    jj_consume_token(FUNSTART);
    // First push the parameter names and their count on the stack.
        // These will be consumed by the MAKE_CLOSURE instruction.
        paramCount = Params();
    jj_consume_token(ARROW);
      m.emit( InstructionSet.CONST, m.interDouble( paramCount ), 3 ) ;
      segNum = m.startSegment() ;
    Block();
    jj_consume_token(FUNEND);
      m.emit( InstructionSet.RETURN ) ;
      m.endSegment() ;
      m.emit( InstructionSet.MAKE_CLOSURE, segNum, 3 ) ;
  }

  final public int Params() throws ParseException, CompileTimeError {
    int count ;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ID:
      count = OneOrMoreParams();
                                  {if (true) return count ;}
      break;
    default:
      jj_la1[10] = jj_gen;
     {if (true) return 0 ;}
    }
    throw new Error("Missing return statement in function");
  }

  final public int OneOrMoreParams() throws ParseException, CompileTimeError {
    int count ;
    Token t ;
    t = jj_consume_token(ID);
                              m.emit( InstructionSet.CONST, m.interString(t.image), 3 ) ;
    count = MoreParams();
                             {if (true) return count + 1 ;}
    throw new Error("Missing return statement in function");
  }

  final public int MoreParams() throws ParseException, CompileTimeError {
    int count ;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMA:
      jj_consume_token(COMMA);
      count = OneOrMoreParams();
                                          {if (true) return count;}
      break;
    default:
      jj_la1[11] = jj_gen;
          {if (true) return 0 ;}
    }
    throw new Error("Missing return statement in function");
  }

  final public void List() throws ParseException, CompileTimeError {
 int count = 0 ;
    jj_consume_token(LBRACKET);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LPAR:
    case LBRACKET:
    case FUNSTART:
    case NUM:
    case ID:
    case STRING:
      Expr();
                  ++count ;
      label_2:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[12] = jj_gen;
          break label_2;
        }
        jj_consume_token(COMMA);
        Expr();
                      ++count ;
      }
      break;
    default:
      jj_la1[13] = jj_gen;
      ;
    }
    jj_consume_token(RBRACKET);
      /*Push Nil*/ m.emit( InstructionSet.CONST, InstructionSet.NIL_ADDRESS, 3 ) ;
      for( int i = 0 ; i < count ; ++i ) m.emit(InstructionSet.CONS) ;
  }

  private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_1(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(0, xla); }
  }

  private boolean jj_3_1() {
    if (jj_scan_token(ID)) return true;
    if (jj_scan_token(BECOMES)) return true;
    return false;
  }

  /** Generated Token Manager. */
  public EOLParserTokenManager token_source;
  SimpleCharStream jj_input_stream;
  /** Current token. */
  public Token token;
  /** Next token. */
  public Token jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  private int jj_gen;
  final private int[] jj_la1 = new int[14];
  static private int[] jj_la1_0;
  static private int[] jj_la1_1;
  static {
      jj_la1_init_0();
      jj_la1_init_1();
   }
   private static void jj_la1_init_0() {
      jj_la1_0 = new int[] {0x20114000,0x1000001,0x21154001,0x20114000,0x40000,0x114000,0x4000,0x114000,0x80000,0x114000,0x0,0x80000,0x80000,0x114000,};
   }
   private static void jj_la1_init_1() {
      jj_la1_1 = new int[] {0xa8,0x0,0xa8,0xa8,0x0,0xa8,0x0,0xa8,0x0,0xa8,0x20,0x0,0x0,0xa8,};
   }
  final private JJCalls[] jj_2_rtns = new JJCalls[1];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  /** Constructor with InputStream. */
  public EOLParser(java.io.InputStream stream) {
     this(stream, null);
  }
  /** Constructor with InputStream and supplied encoding */
  public EOLParser(java.io.InputStream stream, String encoding) {
    try { jj_input_stream = new SimpleCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source = new EOLParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 14; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream) {
     ReInit(stream, null);
  }
  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream, String encoding) {
    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 14; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Constructor. */
  public EOLParser(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new EOLParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 14; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 14; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Constructor with generated Token Manager. */
  public EOLParser(EOLParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 14; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(EOLParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 14; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static private final class LookaheadSuccess extends java.lang.Error { }
  final private LookaheadSuccess jj_ls = new LookaheadSuccess();
  private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    if (jj_scanpos.kind != kind) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) throw jj_ls;
    return false;
  }


/** Get the next Token. */
  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

/** Get the specific Token. */
  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.List<int[]> jj_expentries = new java.util.ArrayList<int[]>();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      jj_entries_loop: for (java.util.Iterator<?> it = jj_expentries.iterator(); it.hasNext();) {
        int[] oldentry = (int[])(it.next());
        if (oldentry.length == jj_expentry.length) {
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              continue jj_entries_loop;
            }
          }
          jj_expentries.add(jj_expentry);
          break jj_entries_loop;
        }
      }
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  /** Generate ParseException. */
  public ParseException generateParseException() {
    jj_expentries.clear();
    boolean[] la1tokens = new boolean[42];
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 14; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 42; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.add(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = jj_expentries.get(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  /** Enable tracing. */
  final public void enable_tracing() {
  }

  /** Disable tracing. */
  final public void disable_tracing() {
  }

  private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 1; i++) {
    try {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
          }
        }
        p = p.next;
      } while (p != null);
      } catch(LookaheadSuccess ls) { }
    }
    jj_rescan = false;
  }

  private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
