package eol;
import static org.junit.Assert.*;

import org.junit.Test;


public class Precedence extends BasicTest {


    @Test
    public void testAddMul0() {
        assertEquals( "45.0"+newline, go("(2 + 3) * (4 + 5) ;" ) ) ;
    }
    
    @Test
    public void testAddMul1() {
        assertEquals( "26.0"+newline, go("2 * 3 + 4 * 5 ;" ) ) ;
    }
    
    @Test
    public void testConsPlus() {
        assertEquals( "(32.0 : 8.0)"+newline, go("22 + 10 : 3 + 5 ;" ) ) ;
    }
    
    @Test
    public void testConsMinus() {
        assertEquals( "(12.0 : -2.0)"+newline, go("22 - 10 : 3 - 5 ;" ) ) ;
    }
    
    @Test
    public void testMulHeadEtc0() {	
        assertEquals( "20.0"+newline,
        		go(" 5 * head [4,5] ;" ) ) ;
        assertEquals( "Execution Time Error"+ newline + newline + "Virtual Machine Error: Operand is not double"+newline,
        		go(" 5 * tail [4,5] ;" ) ) ;
        assertEquals( "Execution Time Error"+ newline + newline + "Virtual Machine Error: Operand is not double"+newline,
        		go(" 5 * null [4,5] ;" ) ) ;
        assertEquals( "Execution Time Error"+ newline + newline + "Virtual Machine Error: Operand is not double"+newline,
        		go(" 5 * atomic [4,5] ;" ) ) ;
    }
    
    @Test
    public void testMulHeadEtc1() {
        assertEquals( "20.0"+newline,
        		go("head [4,5] * 5 ;" ) ) ;
        assertEquals( "Execution Time Error"+ newline + newline + "Virtual Machine Error: Operand is not double"+newline,
        		go("tail [4,5] * 5 ;" ) ) ;
        assertEquals( "Execution Time Error"+ newline + newline + "Virtual Machine Error: Operand is not double"+newline,
        		go("null [4,5] * 5 ;" ) ) ;
        assertEquals( "Execution Time Error"+ newline + newline + "Virtual Machine Error: Operand is not double"+newline,
        		go("atomic [4,5] * 5 ;" ) ) ;
    }
    
    @Test
    public void textCombineUnaries() {
        assertEquals( "3.0"+newline, go(" head tail tail [1,2,3,4,5] ;" ) ) ;
        assertEquals( "[]"+newline, go(" null tail tail [1,2,3] ;" ) ) ;
        assertEquals( "\"true\""+newline, go(" null tail tail tail [1,2,3] ;" ) ) ;
        assertEquals( "\"true\""+newline, go(" atomic head tail [1,2] ;" ) ) ;
        assertEquals( "[]"+newline, go(" atomic head tail [1,[2]] ;" ) ) ;
    }
}
